Index: pjproject/trunk/build.symbian/pjlib_test.mmp
===================================================================
--- pjproject/trunk/build.symbian/pjlib_test.mmp	(revision 2872)
+++ pjproject/trunk/build.symbian/pjlib_test.mmp	(revision 2873)
@@ -28,5 +28,5 @@
 SOURCE	echo_clt.c
 SOURCE	errno.c
-SOURCE	exception.c
+SOURCE	exception_wrap.cpp
 SOURCE	fifobuf.c
 SOURCE	file.c
@@ -39,5 +39,5 @@
 SOURCE	mutex.c
 SOURCE	os.c
-SOURCE	pool.c
+SOURCE	pool_wrap.cpp
 SOURCE	pool_perf.c
 SOURCE	rand.c
@@ -48,5 +48,5 @@
 SOURCE	sock_perf.c
 SOURCE	string.c
-SOURCE	test.c
+SOURCE	test_wrap.cpp
 SOURCE	thread.c
 SOURCE	timer.c
Index: pjproject/trunk/build.symbian/pjlib_util.mmp
===================================================================
--- pjproject/trunk/build.symbian/pjlib_util.mmp	(revision 2872)
+++ pjproject/trunk/build.symbian/pjlib_util.mmp	(revision 2873)
@@ -43,5 +43,5 @@
 SOURCE	md5.c
 SOURCE	pcap.c
-SOURCE	resolver.c
+SOURCE	resolver_wrap.cpp
 SOURCE	scanner.c
 SOURCE	sha1.c
@@ -50,5 +50,5 @@
 SOURCE	stun_simple.c
 SOURCE	stun_simple_client.c
-SOURCE	xml.c
+SOURCE	xml_wrap.cpp
 
 //
Index: pjproject/trunk/build.symbian/pjsdp.mmp
===================================================================
--- pjproject/trunk/build.symbian/pjsdp.mmp	(revision 2872)
+++ pjproject/trunk/build.symbian/pjsdp.mmp	(revision 2873)
@@ -33,5 +33,5 @@
 //
 SOURCE		errno.c
-SOURCE		sdp.c
+SOURCE		sdp_wrap.cpp
 SOURCE		sdp_cmp.c
 SOURCE		sdp_neg.c
Index: pjproject/trunk/build.symbian/pjsip.mmp
===================================================================
--- pjproject/trunk/build.symbian/pjsip.mmp	(revision 2872)
+++ pjproject/trunk/build.symbian/pjsip.mmp	(revision 2873)
@@ -37,16 +37,16 @@
 SOURCE	sip_auth_client.c
 SOURCE	sip_auth_msg.c
-SOURCE	sip_auth_parser.c
+SOURCE	sip_auth_parser_wrap.cpp
 SOURCE	sip_auth_server.c
 SOURCE	sip_config.c
-SOURCE	sip_dialog.c
-SOURCE	sip_endpoint.c
+SOURCE	sip_dialog_wrap.cpp
+SOURCE	sip_endpoint_wrap.cpp
 SOURCE	sip_errno.c
 SOURCE	sip_msg.c
-SOURCE	sip_parser.c
+SOURCE	sip_parser_wrap.cpp
 SOURCE	sip_resolve.c
-SOURCE	sip_tel_uri.c
+SOURCE	sip_tel_uri_wrap.cpp
 SOURCE	sip_transaction.c
-SOURCE	sip_transport.c
+SOURCE	sip_transport_wrap.cpp
 SOURCE	sip_transport_loop.c
 SOURCE	sip_transport_tcp.c
@@ -54,6 +54,6 @@
 SOURCE	sip_ua_layer.c
 SOURCE	sip_uri.c
-SOURCE	sip_util.c
-SOURCE	sip_util_proxy.c
+SOURCE	sip_util_wrap.cpp
+SOURCE	sip_util_proxy_wrap.cpp
 SOURCE	sip_util_statefull.c
 
Index: pjproject/trunk/pjlib-util/src/pjlib-util/resolver_wrap.cpp
===================================================================
--- pjproject/trunk/pjlib-util/src/pjlib-util/resolver_wrap.cpp	(revision 2873)
+++ pjproject/trunk/pjlib-util/src/pjlib-util/resolver_wrap.cpp	(revision 2873)
@@ -0,0 +1,24 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2009 Teluu Inc. (http://www.teluu.com)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+
+/*
+ * This file is a C++ wrapper, see ticket #886 for details.
+ */
+
+#include "resolver.c"
Index: pjproject/trunk/pjlib-util/src/pjlib-util/xml_wrap.cpp
===================================================================
--- pjproject/trunk/pjlib-util/src/pjlib-util/xml_wrap.cpp	(revision 2873)
+++ pjproject/trunk/pjlib-util/src/pjlib-util/xml_wrap.cpp	(revision 2873)
@@ -0,0 +1,24 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2009 Teluu Inc. (http://www.teluu.com)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+
+/*
+ * This file is a C++ wrapper, see ticket #886 for details.
+ */
+
+#include "xml.c"
Index: pjproject/trunk/pjlib/src/pjlib-test/exception_wrap.cpp
===================================================================
--- pjproject/trunk/pjlib/src/pjlib-test/exception_wrap.cpp	(revision 2873)
+++ pjproject/trunk/pjlib/src/pjlib-test/exception_wrap.cpp	(revision 2873)
@@ -0,0 +1,24 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2009 Teluu Inc. (http://www.teluu.com)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+
+/*
+ * This file is a C++ wrapper, see ticket #886 for details.
+ */
+
+#include "exception.c"
Index: pjproject/trunk/pjlib/src/pjlib-test/pool_wrap.cpp
===================================================================
--- pjproject/trunk/pjlib/src/pjlib-test/pool_wrap.cpp	(revision 2873)
+++ pjproject/trunk/pjlib/src/pjlib-test/pool_wrap.cpp	(revision 2873)
@@ -0,0 +1,24 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2009 Teluu Inc. (http://www.teluu.com)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+
+/*
+ * This file is a C++ wrapper, see ticket #886 for details.
+ */
+
+#include "pool.c"
Index: pjproject/trunk/pjlib/src/pjlib-test/test_wrap.cpp
===================================================================
--- pjproject/trunk/pjlib/src/pjlib-test/test_wrap.cpp	(revision 2873)
+++ pjproject/trunk/pjlib/src/pjlib-test/test_wrap.cpp	(revision 2873)
@@ -0,0 +1,24 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2009 Teluu Inc. (http://www.teluu.com)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+
+/*
+ * This file is a C++ wrapper, see ticket #886 for details.
+ */
+
+#include "test.c"
Index: pjproject/trunk/pjmedia/src/pjmedia/sdp_wrap.cpp
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/sdp_wrap.cpp	(revision 2873)
+++ pjproject/trunk/pjmedia/src/pjmedia/sdp_wrap.cpp	(revision 2873)
@@ -0,0 +1,24 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2009 Teluu Inc. (http://www.teluu.com)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+
+/*
+ * This file is a C++ wrapper, see ticket #886 for details.
+ */
+
+#include "sdp.c"
Index: pjproject/trunk/pjsip/src/pjsip/sip_auth_parser_wrap.cpp
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_auth_parser_wrap.cpp	(revision 2873)
+++ pjproject/trunk/pjsip/src/pjsip/sip_auth_parser_wrap.cpp	(revision 2873)
@@ -0,0 +1,24 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2009 Teluu Inc. (http://www.teluu.com)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+
+/*
+ * This file is a C++ wrapper, see ticket #886 for details.
+ */
+
+#include "sip_auth_parser.c"
Index: pjproject/trunk/pjsip/src/pjsip/sip_dialog_wrap.cpp
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_dialog_wrap.cpp	(revision 2873)
+++ pjproject/trunk/pjsip/src/pjsip/sip_dialog_wrap.cpp	(revision 2873)
@@ -0,0 +1,24 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2009 Teluu Inc. (http://www.teluu.com)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+
+/*
+ * This file is a C++ wrapper, see ticket #886 for details.
+ */
+
+#include "sip_dialog.c"
Index: pjproject/trunk/pjsip/src/pjsip/sip_endpoint_wrap.cpp
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_endpoint_wrap.cpp	(revision 2873)
+++ pjproject/trunk/pjsip/src/pjsip/sip_endpoint_wrap.cpp	(revision 2873)
@@ -0,0 +1,24 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2009 Teluu Inc. (http://www.teluu.com)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+
+/*
+ * This file is a C++ wrapper, see ticket #886 for details.
+ */
+
+#include "sip_endpoint.c"
Index: pjproject/trunk/pjsip/src/pjsip/sip_parser_wrap.cpp
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_parser_wrap.cpp	(revision 2873)
+++ pjproject/trunk/pjsip/src/pjsip/sip_parser_wrap.cpp	(revision 2873)
@@ -0,0 +1,24 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2009 Teluu Inc. (http://www.teluu.com)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+
+/*
+ * This file is a C++ wrapper, see ticket #886 for details.
+ */
+
+#include "sip_parser.c"
Index: pjproject/trunk/pjsip/src/pjsip/sip_tel_uri_wrap.cpp
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_tel_uri_wrap.cpp	(revision 2873)
+++ pjproject/trunk/pjsip/src/pjsip/sip_tel_uri_wrap.cpp	(revision 2873)
@@ -0,0 +1,24 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2009 Teluu Inc. (http://www.teluu.com)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+
+/*
+ * This file is a C++ wrapper, see ticket #886 for details.
+ */
+
+#include "sip_tel_uri.c"
Index: pjproject/trunk/pjsip/src/pjsip/sip_transport_wrap.cpp
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_transport_wrap.cpp	(revision 2873)
+++ pjproject/trunk/pjsip/src/pjsip/sip_transport_wrap.cpp	(revision 2873)
@@ -0,0 +1,24 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2009 Teluu Inc. (http://www.teluu.com)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+
+/*
+ * This file is a C++ wrapper, see ticket #886 for details.
+ */
+
+#include "sip_transport.c"
Index: pjproject/trunk/pjsip/src/pjsip/sip_util_proxy_wrap.cpp
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_util_proxy_wrap.cpp	(revision 2873)
+++ pjproject/trunk/pjsip/src/pjsip/sip_util_proxy_wrap.cpp	(revision 2873)
@@ -0,0 +1,24 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2009 Teluu Inc. (http://www.teluu.com)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+
+/*
+ * This file is a C++ wrapper, see ticket #886 for details.
+ */
+
+#include "sip_util_proxy.c"
Index: pjproject/trunk/pjsip/src/pjsip/sip_util_wrap.cpp
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_util_wrap.cpp	(revision 2873)
+++ pjproject/trunk/pjsip/src/pjsip/sip_util_wrap.cpp	(revision 2873)
@@ -0,0 +1,24 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2009 Teluu Inc. (http://www.teluu.com)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+
+/*
+ * This file is a C++ wrapper, see ticket #886 for details.
+ */
+
+#include "sip_util.c"