Index: pjproject/trunk/pjmedia/include/pjmedia-codec/amr_helper.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia-codec/amr_helper.h	(revision 2874)
+++ pjproject/trunk/pjmedia/include/pjmedia-codec/amr_helper.h	(revision 2875)
@@ -34,5 +34,5 @@
 /**
  * @defgroup PJMED_AMR_CODEC_HELPER AMR Codec Helper
- * @ingroup PJMEDIA_CODEC
+ * @ingroup PJMEDIA_CODEC_CODECS
  * @brief AMR common tables and helper functions.
  * @{
Index: pjproject/trunk/pjmedia/include/pjmedia-codec/config.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia-codec/config.h	(revision 2874)
+++ pjproject/trunk/pjmedia/include/pjmedia-codec/config.h	(revision 2875)
@@ -21,5 +21,18 @@
 #define __PJMEDIA_CODEC_CONFIG_H__
 
+/**
+ * @file config.h
+ * @brief PJMEDIA-CODEC compile time settings
+ */
+
+/**
+ * @defgroup pjmedia_codec_config PJMEDIA-CODEC Compile Time Settings
+ * @ingroup PJMEDIA_CODEC
+ * @brief Various compile time settings such as to enable/disable codecs
+ * @{
+ */
+
 #include <pjmedia/types.h>
+
 
 /*
@@ -204,20 +217,45 @@
 #endif
 
+/**
+ * Enable AMR passthrough codec.
+ *
+ * Default: 1
+ */
 #ifndef PJMEDIA_HAS_PASSTHROUGH_CODEC_AMR
 #   define PJMEDIA_HAS_PASSTHROUGH_CODEC_AMR	1
 #endif
 
+/**
+ * Enable G.729 passthrough codec.
+ *
+ * Default: 1
+ */
 #ifndef PJMEDIA_HAS_PASSTHROUGH_CODEC_G729
 #   define PJMEDIA_HAS_PASSTHROUGH_CODEC_G729	1
 #endif
 
+/**
+ * Enable iLBC passthrough codec.
+ *
+ * Default: 1
+ */
 #ifndef PJMEDIA_HAS_PASSTHROUGH_CODEC_ILBC
 #   define PJMEDIA_HAS_PASSTHROUGH_CODEC_ILBC	1
 #endif
 
+/**
+ * Enable PCMU passthrough codec.
+ *
+ * Default: 1
+ */
 #ifndef PJMEDIA_HAS_PASSTHROUGH_CODEC_PCMU
 #   define PJMEDIA_HAS_PASSTHROUGH_CODEC_PCMU	1
 #endif
 
+/**
+ * Enable PCMA passthrough codec.
+ *
+ * Default: 1
+ */
 #ifndef PJMEDIA_HAS_PASSTHROUGH_CODEC_PCMA
 #   define PJMEDIA_HAS_PASSTHROUGH_CODEC_PCMA	1
@@ -272,3 +310,7 @@
 #endif
 
+/**
+ * @}
+ */
+
 #endif	/* __PJMEDIA_CODEC_CONFIG_H__ */
Index: pjproject/trunk/pjmedia/include/pjmedia-codec/g722.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia-codec/g722.h	(revision 2874)
+++ pjproject/trunk/pjmedia/include/pjmedia-codec/g722.h	(revision 2875)
@@ -30,5 +30,5 @@
 /**
  * @defgroup PJMED_G722 G.722 Codec
- * @ingroup PJMEDIA_CODEC
+ * @ingroup PJMEDIA_CODEC_CODECS
  * @brief Implementation of G.722 Codec
  * @{
Index: pjproject/trunk/pjmedia/include/pjmedia-codec/g7221.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia-codec/g7221.h	(revision 2874)
+++ pjproject/trunk/pjmedia/include/pjmedia-codec/g7221.h	(revision 2875)
@@ -30,5 +30,5 @@
 /**
  * @defgroup PJMED_G7221_CODEC G722.1 Codec
- * @ingroup PJMEDIA_CODEC
+ * @ingroup PJMEDIA_CODEC_CODECS
  * @brief Implementation of G722.1 codec
  * @{
Index: pjproject/trunk/pjmedia/include/pjmedia-codec/gsm.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia-codec/gsm.h	(revision 2874)
+++ pjproject/trunk/pjmedia/include/pjmedia-codec/gsm.h	(revision 2875)
@@ -30,5 +30,5 @@
 /**
  * @defgroup PJMED_GSM GSM 06.10 Codec
- * @ingroup PJMEDIA_CODEC
+ * @ingroup PJMEDIA_CODEC_CODECS
  * @brief Implementation of GSM FR based on GSM 06.10 library
  * @{
Index: pjproject/trunk/pjmedia/include/pjmedia-codec/ilbc.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia-codec/ilbc.h	(revision 2874)
+++ pjproject/trunk/pjmedia/include/pjmedia-codec/ilbc.h	(revision 2875)
@@ -30,5 +30,5 @@
 /**
  * @defgroup PJMED_ILBC iLBC Codec
- * @ingroup PJMEDIA_CODEC
+ * @ingroup PJMEDIA_CODEC_CODECS
  * @brief Implementation of iLBC Codec
  * @{
Index: pjproject/trunk/pjmedia/include/pjmedia-codec/ipp_codecs.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia-codec/ipp_codecs.h	(revision 2874)
+++ pjproject/trunk/pjmedia/include/pjmedia-codec/ipp_codecs.h	(revision 2875)
@@ -30,5 +30,5 @@
 /**
  * @defgroup PJMED_IPP_CODEC IPP Codecs
- * @ingroup PJMEDIA_CODEC
+ * @ingroup PJMEDIA_CODEC_CODECS
  * @brief Implementation of IPP codecs
  * @{
Index: pjproject/trunk/pjmedia/include/pjmedia-codec/l16.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia-codec/l16.h	(revision 2874)
+++ pjproject/trunk/pjmedia/include/pjmedia-codec/l16.h	(revision 2875)
@@ -26,5 +26,5 @@
 /**
  * @defgroup PJMED_L16 L16 Codec Family
- * @ingroup PJMEDIA_CODEC
+ * @ingroup PJMEDIA_CODEC_CODECS
  * @brief PCM/16bit/linear codecs
  * @{
Index: pjproject/trunk/pjmedia/include/pjmedia-codec/passthrough.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia-codec/passthrough.h	(revision 2874)
+++ pjproject/trunk/pjmedia/include/pjmedia-codec/passthrough.h	(revision 2875)
@@ -30,5 +30,5 @@
 /**
  * @defgroup PJMED_PASSTHROUGH_CODEC Passthrough Codecs
- * @ingroup PJMEDIA_CODEC
+ * @ingroup PJMEDIA_CODEC_CODECS
  * @brief Implementation of passthrough codecs
  * @{
Index: pjproject/trunk/pjmedia/include/pjmedia-codec/speex.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia-codec/speex.h	(revision 2874)
+++ pjproject/trunk/pjmedia/include/pjmedia-codec/speex.h	(revision 2875)
@@ -30,5 +30,5 @@
 /**
  * @defgroup PJMED_SPEEX Speex Codec Family
- * @ingroup PJMEDIA_CODEC
+ * @ingroup PJMEDIA_CODEC_CODECS
  * @brief Implementation of Speex codecs (narrow/wide/ultrawide-band).
  * @{
Index: pjproject/trunk/pjmedia/include/pjmedia-codec/types.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia-codec/types.h	(revision 2874)
+++ pjproject/trunk/pjmedia/include/pjmedia-codec/types.h	(revision 2875)
@@ -21,5 +21,19 @@
 #define __PJMEDIA_CODEC_TYPES_H__
 
+/**
+ * @file types.h
+ * @brief PJMEDIA-CODEC types and constants
+ */
+
 #include <pjmedia-codec/config.h>
+
+/**
+ * @defgroup pjmedia_codec_types PJMEDIA-CODEC Types and Constants
+ * @ingroup PJMEDIA_CODEC
+ * @brief Constants used by PJMEDIA-CODEC
+ * @{
+ */
+
+
 
 /**
@@ -72,4 +86,7 @@
 };
 
+/**
+ * @}
+ */
 
 
Index: pjproject/trunk/pjmedia/include/pjmedia/codec.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/codec.h	(revision 2874)
+++ pjproject/trunk/pjmedia/include/pjmedia/codec.h	(revision 2875)
@@ -860,4 +860,18 @@
  */
 
+/**
+ * @defgroup PJMEDIA_CODEC_CODECS Supported codecs
+ * @ingroup PJMEDIA_CODEC
+ * @brief Documentation about individual codec supported by PJMEDIA
+ * @{
+ * Please see the APIs provided by the individual codecs below.
+ */
+/**
+ * @}
+ */
+
+
+
+
 PJ_END_DECL
 
Index: pjproject/trunk/pjmedia/include/pjmedia/g711.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/g711.h	(revision 2874)
+++ pjproject/trunk/pjmedia/include/pjmedia/g711.h	(revision 2875)
@@ -29,6 +29,6 @@
 
 /**
- * @defgroup PJMED_G711 G711
- * @ingroup PJMEDIA_CODEC
+ * @defgroup PJMED_G711 G711 G.711 Codec
+ * @ingroup PJMEDIA_CODEC_CODECS
  * @brief Standard G.711/PCMA and PCMU codec.
  * @{